"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeStyleDeclarations = void 0;
var t = __importStar(require("@babel/types"));
var is_automatic_runtime_1 = require("./is-automatic-runtime");
var is_create_element_1 = require("./is-create-element");
/**
 * Returns the children of a `jsx()` call expression.
 *
 * @param node
 * @returns
 */
var getJsxRuntimeChildren = function (node) {
    var props = node.arguments[1];
    var children = [];
    if (t.isObjectExpression(props)) {
        props.properties.forEach(function (prop) {
            if (t.isObjectProperty(prop) && t.isExpression(prop.value)) {
                children.push(prop.value);
            }
        });
    }
    return children;
};
/**
 * Returns the value of a binding.
 *
 * @param identifierName
 * @param parentPath
 */
var getBindingValue = function (identifierName, parentPath) {
    var binding = parentPath.scope.getBinding(identifierName);
    if (binding && t.isVariableDeclarator(binding.path.node)) {
        var value = binding.path.node.init;
        if (value !== null && value !== undefined) {
            return [binding, value];
        }
    }
    return [undefined, undefined];
};
/**
 * Will remove found style declarations tied to the passed in `node`,
 * and callback with any found.
 *
 * @param node
 * @param parentPath
 * @param pass
 */
var removeStyleDeclarations = function (node, parentPath, pass) {
    var processElement = function (element) {
        if (!t.isIdentifier(element)) {
            return;
        }
        var _a = getBindingValue(element.name, parentPath), binding = _a[0], bindingValue = _a[1];
        if (binding && bindingValue && t.isStringLiteral(bindingValue)) {
            pass.styleRules.push(bindingValue.value);
            binding.path.remove();
        }
    };
    if (t.isCallExpression(node) && (0, is_create_element_1.isCreateElement)(node.callee)) {
        // We've found something that looks like React.createElement(CS)
        var children = node.arguments[2];
        if (t.isArrayExpression(children)) {
            for (var _i = 0, _a = children.elements; _i < _a.length; _i++) {
                var element = _a[_i];
                processElement(element);
            }
        }
        return;
    }
    if ((0, is_automatic_runtime_1.isAutomaticRuntime)(node, 'jsx')) {
        // We've found something that looks like _jsx(CS)
        var styles = getJsxRuntimeChildren(node)[0];
        if (t.isArrayExpression(styles)) {
            for (var _b = 0, _c = styles.elements; _b < _c.length; _b++) {
                var element = _c[_b];
                processElement(element);
            }
        }
        return;
    }
    if (t.isJSXElement(node) &&
        t.isJSXIdentifier(node.openingElement.name) &&
        node.openingElement.name.name === 'CS') {
        // We've found something that looks like <CS>
        var styles = node.children[0];
        if (t.isJSXExpressionContainer(styles) && t.isArrayExpression(styles.expression)) {
            for (var _d = 0, _e = styles.expression.elements; _d < _e.length; _d++) {
                var element = _e[_d];
                processElement(element);
            }
        }
        return;
    }
};
exports.removeStyleDeclarations = removeStyleDeclarations;
//# sourceMappingURL=remove-style-declarations.js.map